# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 api_url: Optional[pulumi.Input[str]] = None,
                 auth_token: Optional[pulumi.Input[str]] = None,
                 custom_app_url: Optional[pulumi.Input[str]] = None,
                 retry_max_attempts: Optional[pulumi.Input[int]] = None,
                 retry_wait_max_seconds: Optional[pulumi.Input[int]] = None,
                 retry_wait_min_seconds: Optional[pulumi.Input[int]] = None,
                 timeout_seconds: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] api_url: API URL for your SignalFx org, may include a realm
        :param pulumi.Input[str] auth_token: SignalFx auth token
        :param pulumi.Input[str] custom_app_url: Application URL for your SignalFx org, often customized for organizations using SSO
        :param pulumi.Input[int] retry_max_attempts: Max retries for a single HTTP call. Defaults to 4
        :param pulumi.Input[int] retry_wait_max_seconds: Maximum retry wait for a single HTTP call in seconds. Defaults to 30
        :param pulumi.Input[int] retry_wait_min_seconds: Minimum retry wait for a single HTTP call in seconds. Defaults to 1
        :param pulumi.Input[int] timeout_seconds: Timeout duration for a single HTTP call in seconds. Defaults to 120
        """
        ProviderArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            api_url=api_url,
            auth_token=auth_token,
            custom_app_url=custom_app_url,
            retry_max_attempts=retry_max_attempts,
            retry_wait_max_seconds=retry_wait_max_seconds,
            retry_wait_min_seconds=retry_wait_min_seconds,
            timeout_seconds=timeout_seconds,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             api_url: Optional[pulumi.Input[str]] = None,
             auth_token: Optional[pulumi.Input[str]] = None,
             custom_app_url: Optional[pulumi.Input[str]] = None,
             retry_max_attempts: Optional[pulumi.Input[int]] = None,
             retry_wait_max_seconds: Optional[pulumi.Input[int]] = None,
             retry_wait_min_seconds: Optional[pulumi.Input[int]] = None,
             timeout_seconds: Optional[pulumi.Input[int]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if api_url is not None:
            _setter("api_url", api_url)
        if auth_token is not None:
            _setter("auth_token", auth_token)
        if custom_app_url is not None:
            _setter("custom_app_url", custom_app_url)
        if retry_max_attempts is not None:
            _setter("retry_max_attempts", retry_max_attempts)
        if retry_wait_max_seconds is not None:
            _setter("retry_wait_max_seconds", retry_wait_max_seconds)
        if retry_wait_min_seconds is not None:
            _setter("retry_wait_min_seconds", retry_wait_min_seconds)
        if timeout_seconds is not None:
            _setter("timeout_seconds", timeout_seconds)

    @property
    @pulumi.getter(name="apiUrl")
    def api_url(self) -> Optional[pulumi.Input[str]]:
        """
        API URL for your SignalFx org, may include a realm
        """
        return pulumi.get(self, "api_url")

    @api_url.setter
    def api_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_url", value)

    @property
    @pulumi.getter(name="authToken")
    def auth_token(self) -> Optional[pulumi.Input[str]]:
        """
        SignalFx auth token
        """
        return pulumi.get(self, "auth_token")

    @auth_token.setter
    def auth_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auth_token", value)

    @property
    @pulumi.getter(name="customAppUrl")
    def custom_app_url(self) -> Optional[pulumi.Input[str]]:
        """
        Application URL for your SignalFx org, often customized for organizations using SSO
        """
        return pulumi.get(self, "custom_app_url")

    @custom_app_url.setter
    def custom_app_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "custom_app_url", value)

    @property
    @pulumi.getter(name="retryMaxAttempts")
    def retry_max_attempts(self) -> Optional[pulumi.Input[int]]:
        """
        Max retries for a single HTTP call. Defaults to 4
        """
        return pulumi.get(self, "retry_max_attempts")

    @retry_max_attempts.setter
    def retry_max_attempts(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "retry_max_attempts", value)

    @property
    @pulumi.getter(name="retryWaitMaxSeconds")
    def retry_wait_max_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum retry wait for a single HTTP call in seconds. Defaults to 30
        """
        return pulumi.get(self, "retry_wait_max_seconds")

    @retry_wait_max_seconds.setter
    def retry_wait_max_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "retry_wait_max_seconds", value)

    @property
    @pulumi.getter(name="retryWaitMinSeconds")
    def retry_wait_min_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        Minimum retry wait for a single HTTP call in seconds. Defaults to 1
        """
        return pulumi.get(self, "retry_wait_min_seconds")

    @retry_wait_min_seconds.setter
    def retry_wait_min_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "retry_wait_min_seconds", value)

    @property
    @pulumi.getter(name="timeoutSeconds")
    def timeout_seconds(self) -> Optional[pulumi.Input[int]]:
        """
        Timeout duration for a single HTTP call in seconds. Defaults to 120
        """
        return pulumi.get(self, "timeout_seconds")

    @timeout_seconds.setter
    def timeout_seconds(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "timeout_seconds", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_url: Optional[pulumi.Input[str]] = None,
                 auth_token: Optional[pulumi.Input[str]] = None,
                 custom_app_url: Optional[pulumi.Input[str]] = None,
                 retry_max_attempts: Optional[pulumi.Input[int]] = None,
                 retry_wait_max_seconds: Optional[pulumi.Input[int]] = None,
                 retry_wait_min_seconds: Optional[pulumi.Input[int]] = None,
                 timeout_seconds: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        The provider type for the signalfx package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] api_url: API URL for your SignalFx org, may include a realm
        :param pulumi.Input[str] auth_token: SignalFx auth token
        :param pulumi.Input[str] custom_app_url: Application URL for your SignalFx org, often customized for organizations using SSO
        :param pulumi.Input[int] retry_max_attempts: Max retries for a single HTTP call. Defaults to 4
        :param pulumi.Input[int] retry_wait_max_seconds: Maximum retry wait for a single HTTP call in seconds. Defaults to 30
        :param pulumi.Input[int] retry_wait_min_seconds: Minimum retry wait for a single HTTP call in seconds. Defaults to 1
        :param pulumi.Input[int] timeout_seconds: Timeout duration for a single HTTP call in seconds. Defaults to 120
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the signalfx package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            ProviderArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_url: Optional[pulumi.Input[str]] = None,
                 auth_token: Optional[pulumi.Input[str]] = None,
                 custom_app_url: Optional[pulumi.Input[str]] = None,
                 retry_max_attempts: Optional[pulumi.Input[int]] = None,
                 retry_wait_max_seconds: Optional[pulumi.Input[int]] = None,
                 retry_wait_min_seconds: Optional[pulumi.Input[int]] = None,
                 timeout_seconds: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            __props__.__dict__["api_url"] = api_url
            __props__.__dict__["auth_token"] = auth_token
            __props__.__dict__["custom_app_url"] = custom_app_url
            __props__.__dict__["retry_max_attempts"] = pulumi.Output.from_input(retry_max_attempts).apply(pulumi.runtime.to_json) if retry_max_attempts is not None else None
            __props__.__dict__["retry_wait_max_seconds"] = pulumi.Output.from_input(retry_wait_max_seconds).apply(pulumi.runtime.to_json) if retry_wait_max_seconds is not None else None
            __props__.__dict__["retry_wait_min_seconds"] = pulumi.Output.from_input(retry_wait_min_seconds).apply(pulumi.runtime.to_json) if retry_wait_min_seconds is not None else None
            __props__.__dict__["timeout_seconds"] = pulumi.Output.from_input(timeout_seconds).apply(pulumi.runtime.to_json) if timeout_seconds is not None else None
        super(Provider, __self__).__init__(
            'signalfx',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter(name="apiUrl")
    def api_url(self) -> pulumi.Output[Optional[str]]:
        """
        API URL for your SignalFx org, may include a realm
        """
        return pulumi.get(self, "api_url")

    @property
    @pulumi.getter(name="authToken")
    def auth_token(self) -> pulumi.Output[Optional[str]]:
        """
        SignalFx auth token
        """
        return pulumi.get(self, "auth_token")

    @property
    @pulumi.getter(name="customAppUrl")
    def custom_app_url(self) -> pulumi.Output[Optional[str]]:
        """
        Application URL for your SignalFx org, often customized for organizations using SSO
        """
        return pulumi.get(self, "custom_app_url")

